/*
 * exthooks.c: Additional hooks for 3rd party plugins
 *
 * Licensed under GPL2
 */

#include "exthooks.h"

bool cExtHooks::pastTimers = false;

bool cExtHooks::oneReady = false;
cExtHookGroupOne *cExtHooks::oneCustom = NULL;
cExtHookGroupOne cExtHooks::oneDefault;

bool cExtHooks::twoReady = false;
cExtHookGroupTwo *cExtHooks::twoCustom = NULL;
cExtHookGroupTwo cExtHooks::twoDefault;

cExtHookGroupOne *cExtHooks::One()
{
	if (oneReady)
		return oneCustom;
	else
		return &oneDefault;
}
cExtHookGroupTwo *cExtHooks::Two()
{
	if (twoReady)
		return twoCustom;
	else
		return &twoDefault;
}

bool cExtHooks::RegisterGroupOne(cExtHookGroupOne *hooks)
{
	if (oneReady) {
		delete hooks;
		esyslog("ERROR: tried to re-register hook group one!");
		return false;
	}
	oneCustom = hooks;
	oneReady = true;
	dsyslog("Hook group one has been registered by a plugin");
	return true;
}

bool cExtHooks::RegisterGroupTwo(cExtHookGroupTwo *hooks)
{
	if (twoReady) {
		delete hooks;
		esyslog("ERROR: tried to re-register hook group two!");
		return false;
	}
	twoCustom = hooks;
	twoReady = true;
	dsyslog("Hook group two has been registered by a plugin");
	return true;
}

void cExtHooks::UnregisterGroupOne()
{
	dsyslog("Hook group one unregistered");
	oneReady = false;
	oneCustom = &oneDefault;
}
void cExtHooks::UnregisterGroupTwo()
{
	dsyslog("Hook group two unregistered");
	twoReady = false;
	twoCustom = &twoDefault;
}
